#include <jni.h>
#include <android/log.h>
#include <libtncconfig.h>
#include <stdio.h>
#include <string.h>
#include <base64.h>
#include <libtnctncc.h>
#include <libtnctncs.h>
#include <libtncarray.h>

libtnc_tncc_connection* myImcConn;
libtnc_tncs_connection* myImvConn;

jint Java_de_fhg_sit_tnctest_JNITest_testTNC(JNIEnv* env, jobject thiz) {

    setvbuf(stdout, NULL, _IONBF, 0);
    setvbuf(stderr, NULL, _IONBF, 0);

	fprintf(stdout,"HALLO1234");
	__android_log_write(ANDROID_LOG_ERROR,"TNCC/TNCS","Starting TNCC/TNCS Initialization");

	char buf[1000];
	const char* filename="/sdcard/tnc.config";

	unsigned long retval = libtnc_tncc_Initialize(filename);

	sprintf(buf, "Init TNCC (0 == OK): %d", retval);
	__android_log_write(ANDROID_LOG_ERROR,"TNCC",buf);


	retval = libtnc_tncs_Initialize(filename);
	sprintf(buf, "Init TNCS (0 == OK): %d", retval);
	__android_log_write(ANDROID_LOG_ERROR,"TNCS",buf);

	libtnc_tncc_PreferredLanguage("en");

	myImcConn = libtnc_tncc_CreateConnection(NULL);

	__android_log_write(ANDROID_LOG_ERROR,"TNCC","Created IMC/TNCC Connection");

	myImvConn = libtnc_tncs_CreateConnection(NULL);


	myImvConn->have_recommendation=0;
	__android_log_write(ANDROID_LOG_ERROR,"TNCC","Created IMV/TNCS Connection");
	sprintf(buf, "have_recommendation: %d", myImvConn->have_recommendation);
	__android_log_write(ANDROID_LOG_ERROR,"TNCS",buf);

	retval = libtnc_tncs_BeginSession(myImvConn);
	retval = libtnc_tncc_BeginSession(myImcConn);

	sprintf(buf, "Starting Session (TNCC) (0==OK): %d", retval);
	__android_log_write(ANDROID_LOG_ERROR,"TNCC",buf);

	return (jint)retval;
}

TNC_Result TNC_TNCS_SendBatch(
    /*in*/ libtnc_tncs_connection* conn,
    /*in*/ const char* messageBuffer,
    /*in*/ size_t messageLength)
{
    printf("TNC_TNCS_SendBatch123: %s\n", messageBuffer);

    return libtnc_tncc_ReceiveBatch(myImcConn, messageBuffer, messageLength);
}

TNC_Result TNC_TNCC_SendBatch(
    /*in*/ libtnc_tncc_connection* conn,
    /*in*/ const char* messageBuffer,
    /*in*/ size_t messageLength)
{
    printf("TNC_TNCC_SendBatch: %s\n", messageBuffer);
    return libtnc_tncs_ReceiveBatch(myImvConn, messageBuffer, messageLength);
}
